VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Line Count Example"
   ClientHeight    =   4740
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4740
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   25
      Left            =   1680
      Top             =   4200
   End
   Begin VB.PictureBox picLines 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Serif"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4740
      Left            =   0
      ScaleHeight     =   4740
      ScaleWidth      =   495
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Width           =   495
   End
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   4695
      Left            =   480
      TabIndex        =   0
      Top             =   0
      Width           =   4575
      _ExtentX        =   8070
      _ExtentY        =   8281
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"Form1.frx":0000
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This Code was Created By Bryan Cairns
'Also this code is FREE so please do with it as you see fit
'
'The procedure is really simple, just use a timer control to call
'the Drawlines Sub which counts the current lines in a Rich text box
'and finds the 1st visible line, and the current line
'then it uses the print function to display the line numbers.
'Also to speed things up, the Drawlines Sub is called when the user
'interacts with the Rich text Box.
'have fun :) Bryan Cairns
'http://www.html-helper.com
'cairnsb@html-helper.com

Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_LINEINDEX = &HBB
Private Const EM_LINELENGTH = &HC1
Private Const EM_GETFIRSTVISIBLELINE = &HCE

Private Sub DrawLines(picTo As PictureBox, RTF As RichTextBox)
Dim iLine As Long, cLine As Long, vLine As Long
'count the lines
iLine = SendMessage(RTF.hwnd, EM_GETLINECOUNT, ByVal 0&, ByVal 0&)
'current line
cLine = 1 + RTF.GetLineFromChar(RTF.SelStart)
'first visible line
vLine = SendMessage(RTF.hwnd, EM_GETFIRSTVISIBLELINE, ByVal 0&, ByVal 0&)
picTo.Cls

picTo.Font = RTF.Font
picTo.ForeColor = &H8000000C
Dim I As Integer
For I = vLine + 1 To iLine
If I <> cLine Then
picTo.ForeColor = &H8000000C
picTo.Print I
Else
If I = cLine Then
picTo.ForeColor = &H80000018
picTo.Print I
End If
End If
Next I
End Sub

Private Sub Form_Load()
RichTextBox1.SelText = RichTextBox1.SelText & "This is an example of how to display" & vbCrLf
RichTextBox1.SelText = RichTextBox1.SelText & "the line count and current line in a Rich Text Box." & vbCrLf
RichTextBox1.SelText = RichTextBox1.SelText & vbCrLf
RichTextBox1.SelText = RichTextBox1.SelText & "cairnsb@html-helper.com"
RichTextBox1.SelStart = 0
picLines.Top = RichTextBox1.Top + 50
picLines.Height = RichTextBox1.Height
DrawLines picLines, RichTextBox1
End Sub

Private Sub RichTextBox1_Change()
DrawLines picLines, RichTextBox1
End Sub

Private Sub RichTextBox1_KeyPress(KeyAscii As Integer)
DrawLines picLines, RichTextBox1
End Sub

Private Sub RichTextBox1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
DrawLines picLines, RichTextBox1
End Sub

Private Sub Timer1_Timer()
DrawLines picLines, RichTextBox1
End Sub
